package DB

import org.jetbrains.exposed.dao.IntEntity
import org.jetbrains.exposed.dao.IntEntityClass
import org.jetbrains.exposed.dao.id.EntityID
import org.jetbrains.exposed.dao.id.IntIdTable

object Migrations : IntIdTable() {
    val identifier = varchar("identifier", 256)
    val done = bool("done").default(false)
}

class Migration(id: EntityID<Int>) : IntEntity(id) {
    companion object : IntEntityClass<Migration>(Migrations)

    var identifier by Migrations.identifier
    var done by Migrations.done
}