import DB.Migration
import DB.Migrations
import org.jetbrains.exposed.sql.transactions.transaction
import org.jetbrains.exposed.sql.update

class MigrationsController {
    private val migrations: Map<String, () -> Boolean> = mapOf(
    )

    fun checkMigrationsToDo() {
        this.migrations.forEach {
            transaction {
                val migrationWithName = Migration.find { Migrations.identifier eq it.key }.firstOrNull()
                if (migrationWithName == null) {
                    Migration.new {
                        identifier = it.key
                    }
                    println("Migration ${it.key} will start now.")
                    it.value()
                    Migrations.update({Migrations.identifier eq it.key}) {
                        it[done] = true
                    }
                    println("Migration ${it.key} done.")
                } else if (!migrationWithName.done) {
                    println("Migration ${it.key} not done yet. Redoing.")
                    it.value()
                    Migrations.update({Migrations.identifier eq it.key}) {
                        it[done] = true
                    }
                    println("Migration ${it.key} done.")
                } else {
                    println("Migration ${it.key} already done.")
                }
            }
        }
    }

   
}